diff --git a/libavformat/Makefile b/libavformat/Makefile
index 266b77a..faca4a0 100644
--- a/libavformat/Makefile
+++ b/libavformat/Makefile
@@ -165,6 +165,7 @@ OBJS-$(CONFIG_FIFO_MUXER)                += fifo.o
 OBJS-$(CONFIG_FILMSTRIP_DEMUXER)         += filmstripdec.o
 OBJS-$(CONFIG_FILMSTRIP_MUXER)           += filmstripenc.o
 OBJS-$(CONFIG_FITS_DEMUXER)              += fitsdec.o
+OBJS-$(CONFIG_FITS_MUXER)                += fitsenc.o
 OBJS-$(CONFIG_FLAC_DEMUXER)              += flacdec.o rawdec.o \
                                             flac_picture.o   \
                                             oggparsevorbis.o \
diff --git a/libavformat/allformats.c b/libavformat/allformats.c
index 3c12760..f3b2edb 100644
--- a/libavformat/allformats.c
+++ b/libavformat/allformats.c
@@ -121,7 +121,7 @@ static void register_all(void)
     REGISTER_MUXDEMUX(FFMETADATA,       ffmetadata);
     REGISTER_MUXER   (FIFO,             fifo);
     REGISTER_MUXDEMUX(FILMSTRIP,        filmstrip);
-    REGISTER_DEMUXER (FITS,             fits);
+    REGISTER_MUXDEMUX(FITS,             fits);
     REGISTER_MUXDEMUX(FLAC,             flac);
     REGISTER_DEMUXER (FLIC,             flic);
     REGISTER_MUXDEMUX(FLV,              flv);
diff --git a/libavformat/fitsenc.c b/libavformat/fitsenc.c
new file mode 100644
index 0000000..0dcdcdf
--- /dev/null
+++ b/libavformat/fitsenc.c
@@ -0,0 +1,183 @@
+/*
+ * FITS muxer
+ * Copyright (c) 2017 Paras Chadha
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+/**
+ * @file
+ * FITS muxer.
+ */
+
+#include "internal.h"
+
+typedef struct FITSContext {
+    int first_image;
+} FITSContext;
+
+static int fits_write_header(AVFormatContext *s)
+{
+    FITSContext *fitsctx = s->priv_data;
+    fitsctx->first_image = 1;
+    return 0;
+}
+
+/**
+ * Write one header line comprising of keyword and value(int)
+ * @param s AVFormat Context
+ * @param keyword pointer to the char array in which keyword is stored
+ * @param value the value corresponding to the keyword
+ * @param lines_written to keep track of lines written so far
+ * @return 0
+ */
+static int write_keyword_value(AVFormatContext *s, const char *keyword, int value, int *lines_written)
+{
+    int len, ret;
+    uint8_t header[80];
+
+    len = strlen(keyword);
+    memset(header, ' ', sizeof(header));
+    memcpy(header, keyword, len);
+
+    header[8] = '=';
+    header[9] = ' ';
+
+    ret = snprintf(header + 10, 70, "%d", value);
+    header[ret + 10] = ' ';
+
+    avio_write(s->pb, header, sizeof(header));
+    *lines_written += 1;
+    return 0;
+}
+
+static int write_image_header(AVFormatContext *s)
+{
+    AVStream *st = s->streams[0];
+    AVCodecParameters *encctx = st->codecpar;
+    FITSContext *fitsctx = s->priv_data;
+    uint8_t buffer[80];
+    int bitpix, naxis, naxis3 = 1, bzero = 0, rgb = 0, lines_written = 0, lines_left;
+
+    switch (encctx->format) {
+        case AV_PIX_FMT_GRAY8:
+            bitpix = 8;
+            naxis = 2;
+            break;
+        case AV_PIX_FMT_GRAY16BE:
+            bitpix = 16;
+            naxis = 2;
+            bzero = 32768;
+            break;
+        case AV_PIX_FMT_GBRP:
+        case AV_PIX_FMT_GBRAP:
+            bitpix = 8;
+            naxis = 3;
+            rgb = 1;
+            if (encctx->format == AV_PIX_FMT_GBRP) {
+                naxis3 = 3;
+            } else {
+                naxis3 = 4;
+            }
+            break;
+        case AV_PIX_FMT_GBRP16BE:
+        case AV_PIX_FMT_GBRAP16BE:
+            bitpix = 16;
+            naxis = 3;
+            rgb = 1;
+            if (encctx->format == AV_PIX_FMT_GBRP16BE) {
+                naxis3 = 3;
+            } else {
+                naxis3 = 4;
+            }
+            bzero = 32768;
+            break;
+    }
+
+    if (fitsctx->first_image) {
+        memcpy(buffer, "SIMPLE  = ", 10);
+        memset(buffer + 10, ' ', 70);
+        buffer[29] = 'T';
+        avio_write(s->pb, buffer, sizeof(buffer));
+    } else {
+        memcpy(buffer, "XTENSION= 'IMAGE   '", 20);
+        memset(buffer + 20, ' ', 60);
+        avio_write(s->pb, buffer, sizeof(buffer));
+    }
+    lines_written++;
+
+    write_keyword_value(s, "BITPIX", bitpix, &lines_written);         // no of bits per pixel
+    write_keyword_value(s, "NAXIS", naxis, &lines_written);           // no of dimensions of image
+    write_keyword_value(s, "NAXIS1", encctx->width, &lines_written);   // first dimension i.e. width
+    write_keyword_value(s, "NAXIS2", encctx->height, &lines_written);  // second dimension i.e. height
+
+    if (rgb)
+        write_keyword_value(s, "NAXIS3", naxis3, &lines_written);     // third dimension to store RGBA planes
+
+    if (!fitsctx->first_image) {
+        write_keyword_value(s, "PCOUNT", 0, &lines_written);
+        write_keyword_value(s, "GCOUNT", 1, &lines_written);
+    } else {
+        fitsctx->first_image = 0;
+    }
+
+    /*
+     * Since FITS does not support unsigned 16 bit integers,
+     * BZERO = 32768 is used to store unsigned 16 bit integers as
+     * signed integers so that it can be read properly.
+     */
+    if (bitpix == 16)
+        write_keyword_value(s, "BZERO", bzero, &lines_written);
+
+    if (rgb) {
+        memcpy(buffer, "CTYPE3  = 'RGB     '", 20);
+        memset(buffer + 20, ' ', 60);
+        avio_write(s->pb, buffer, sizeof(buffer));
+        lines_written++;
+    }
+
+    memcpy(buffer, "END", 3);
+    memset(buffer + 3, ' ', 77);
+    avio_write(s->pb, buffer, sizeof(buffer));
+    lines_written++;
+
+    lines_left = ((lines_written + 35) / 36) * 36 - lines_written;
+    memset(buffer, ' ', 80);
+    while (lines_left > 0) {
+        avio_write(s->pb, buffer, sizeof(buffer));
+        lines_left--;
+    }
+    return 0;
+}
+
+static int fits_write_packet(AVFormatContext *s, AVPacket *pkt)
+{
+    write_image_header(s);
+    avio_write(s->pb, pkt->data, pkt->size);
+    return 0;
+}
+
+AVOutputFormat ff_fits_muxer = {
+    .name         = "fits",
+    .long_name    = NULL_IF_CONFIG_SMALL("Flexible Image Transport System"),
+    .extensions   = "fits",
+    .priv_data_size = sizeof(FITSContext),
+    .audio_codec  = AV_CODEC_ID_NONE,
+    .video_codec  = AV_CODEC_ID_FITS,
+    .write_header = fits_write_header,
+    .write_packet = fits_write_packet,
+};
diff --git a/libavformat/img2enc.c b/libavformat/img2enc.c
index 1297b1a..87b5ec2 100644
--- a/libavformat/img2enc.c
+++ b/libavformat/img2enc.c
@@ -62,6 +62,8 @@ static int write_header(AVFormatContext *s)

     if (st->codecpar->codec_id == AV_CODEC_ID_GIF) {
         img->muxer = "gif";
+    } else if (st->codecpar->codec_id == AV_CODEC_ID_FITS) {
+        img->muxer = "fits";
     } else if (st->codecpar->codec_id == AV_CODEC_ID_RAWVIDEO) {
         const char *str = strrchr(img->path, '.');
         img->split_planes =     str
diff --git a/tests/fate/avformat.mak b/tests/fate/avformat.mak
index 82a531c..c4cf2bc 100644
--- a/tests/fate/avformat.mak
+++ b/tests/fate/avformat.mak
@@ -10,6 +10,7 @@ FATE_LAVF-$(call ENCDEC,  PCM_S16BE,             CAF)                += caf
 FATE_LAVF-$(call ENCDEC,  DPX,                   IMAGE2)             += dpx
 FATE_LAVF-$(call ENCDEC2, DVVIDEO,    PCM_S16LE, AVI)                += dv_fmt
 FATE_LAVF-$(call ENCDEC2, MPEG1VIDEO, MP2,       FFM)                += ffm
+FATE_LAVF-$(call ENCDEC,  FITS,                  IMAGE2)             += fits
 FATE_LAVF-$(call ENCDEC,  RAWVIDEO,              FILMSTRIP)          += flm
 FATE_LAVF-$(call ENCDEC,  FLV,                   FLV)                += flv_fmt
 FATE_LAVF-$(call ENCDEC,  GIF,                   IMAGE2)             += gif
diff --git a/tests/lavf-regression.sh b/tests/lavf-regression.sh
index eda40f2..d9026de 100755
--- a/tests/lavf-regression.sh
+++ b/tests/lavf-regression.sh
@@ -230,6 +230,15 @@ do_avconv $file $DEC_OPTS -f image2 -vcodec pgmyuv -i $raw_src $ENC_OPTS -t 1 -q
 #do_avconv_crc $file -i $target_path/$file
 fi

+if [ -n "$do_fits" ] ; then
+pix_fmts="gray gray16be gbrp gbrap gbrp16be gbrap16be"
+for pix_fmt in $pix_fmts ; do
+    file=${outfile}${pix_fmt}lavf.fits
+    do_avconv $file $DEC_OPTS -f image2 -vcodec pgmyuv -i $raw_src $ENC_OPTS -pix_fmt $pix_fmt
+    do_avconv_crc $file $DEC_OPTS -i $target_path/$file -pix_fmt $pix_fmt
+done
+fi
+
 # image formats

 if [ -n "$do_pgm" ] ; then
diff --git a/tests/ref/lavf/fits b/tests/ref/lavf/fits
new file mode 100644
index 0000000..489542b
--- /dev/null
+++ b/tests/ref/lavf/fits
@@ -0,0 +1,18 @@
+ed9fd697d0d782df6201f6a2db184552 *./tests/data/lavf/graylavf.fits
+5328000 ./tests/data/lavf/graylavf.fits
+./tests/data/lavf/graylavf.fits CRC=0xbacf446c
+48e6caf6a59e32f9a8a39979c9183a7f *./tests/data/lavf/gray16belavf.fits
+10368000 ./tests/data/lavf/gray16belavf.fits
+./tests/data/lavf/gray16belavf.fits CRC=0xae2b58d4
+be2f7112fd193c9a909304c81e662769 *./tests/data/lavf/gbrplavf.fits
+15408000 ./tests/data/lavf/gbrplavf.fits
+./tests/data/lavf/gbrplavf.fits CRC=0x04ed3828
+c89a72185cfad363aa9cc42e84fed301 *./tests/data/lavf/gbraplavf.fits
+20448000 ./tests/data/lavf/gbraplavf.fits
+./tests/data/lavf/gbraplavf.fits CRC=0x032a6409
+d539b9e02f5ab8fb85717c8adb60b6cc *./tests/data/lavf/gbrp16belavf.fits
+30672000 ./tests/data/lavf/gbrp16belavf.fits
+./tests/data/lavf/gbrp16belavf.fits CRC=0x81897ff7
+3dc3622fb09a338b406d8a12a30f2545 *./tests/data/lavf/gbrap16belavf.fits
+40752000 ./tests/data/lavf/gbrap16belavf.fits
+./tests/data/lavf/gbrap16belavf.fits CRC=0x247dd7b9