diff --git a/libavformat/Makefile b/libavformat/Makefile
index 4bffdf2205..734b703862 100644
--- a/libavformat/Makefile
+++ b/libavformat/Makefile
@@ -331,6 +331,7 @@ OBJS-$(CONFIG_MXF_MUXER)                 += mxfenc.o mxf.o audiointerleave.o
 OBJS-$(CONFIG_MXG_DEMUXER)               += mxg.o
 OBJS-$(CONFIG_NC_DEMUXER)                += ncdec.o
 OBJS-$(CONFIG_NISTSPHERE_DEMUXER)        += nistspheredec.o pcm.o
+OBJS-$(CONFIG_NSP_DEMUXER)               += nspdec.o
 OBJS-$(CONFIG_NSV_DEMUXER)               += nsvdec.o
 OBJS-$(CONFIG_NULL_MUXER)                += nullenc.o
 OBJS-$(CONFIG_NUT_DEMUXER)               += nutdec.o nut.o isom.o
diff --git a/libavformat/allformats.c b/libavformat/allformats.c
index 9213af9301..6a9b9883c9 100644
--- a/libavformat/allformats.c
+++ b/libavformat/allformats.c
@@ -224,6 +224,7 @@ static void register_all(void)
     REGISTER_DEMUXER (MXG,              mxg);
     REGISTER_DEMUXER (NC,               nc);
     REGISTER_DEMUXER (NISTSPHERE,       nistsphere);
+    REGISTER_DEMUXER (NSP,              nsp);
     REGISTER_DEMUXER (NSV,              nsv);
     REGISTER_MUXER   (NULL,             null);
     REGISTER_MUXDEMUX(NUT,              nut);
diff --git a/libavformat/nspdec.c b/libavformat/nspdec.c
new file mode 100644
index 0000000000..d2ff779732
--- /dev/null
+++ b/libavformat/nspdec.c
@@ -0,0 +1,101 @@
+/*
+ * NSP demuxer
+ * Copyright (c) 2017 Paul B Mahol
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "libavutil/avstring.h"
+#include "libavutil/intreadwrite.h"
+#include "avformat.h"
+#include "internal.h"
+#include "pcm.h"
+
+static int nsp_probe(AVProbeData *p)
+{
+    if (AV_RB32(p->buf) == AV_RB32("FORM") &&
+        AV_RB32(p->buf + 4) == AV_RB32("DS16"))
+        return AVPROBE_SCORE_MAX;
+    return 0;
+}
+
+static int nsp_read_header(AVFormatContext *s)
+{
+    int rate = 0, channels = 0;
+    uint32_t chunk, size;
+    AVStream *st;
+    int64_t pos;
+
+    avio_skip(s->pb, 12);
+    st = avformat_new_stream(s, NULL);
+    if (!st)
+        return AVERROR(ENOMEM);
+
+    while (!avio_feof(s->pb)) {
+        chunk = avio_rb32(s->pb);
+        size  = avio_rl32(s->pb);
+        pos   = avio_tell(s->pb);
+
+        if (chunk == MKBETAG('H', 'D', 'R', '8') ||
+            chunk == MKBETAG('H', 'E', 'D', 'R')) {
+            if (size < 32)
+                return AVERROR_INVALIDDATA;
+            avio_skip(s->pb, 20);
+            rate = avio_rl32(s->pb);
+            avio_skip(s->pb, size - (avio_tell(s->pb) - pos));
+        } else if (chunk == MKBETAG('N', 'O', 'T', 'E')) {
+            char value[1024];
+
+            avio_get_str(s->pb, size, value, sizeof(value));
+            av_dict_set(&s->metadata, "Note", value, 0);
+            avio_skip(s->pb, 1);
+        } else if (chunk == MKBETAG('S', 'D', 'A', 'B')) {
+            channels = 2;
+            break;
+        } else if (chunk == MKBETAG('S', 'D', 'A', '_') ||
+                   chunk == MKBETAG('S', 'D', '_', 'A') ||
+                   chunk == MKBETAG('S', 'D', '_', '2') ||
+                   chunk == MKBETAG('S', 'D', '_', '3') ||
+                   chunk == MKBETAG('S', 'D', '_', '4') ||
+                   chunk == MKBETAG('S', 'D', '_', '5') ||
+                   chunk == MKBETAG('S', 'D', '_', '6') ||
+                   chunk == MKBETAG('S', 'D', '_', '7') ||
+                   chunk == MKBETAG('S', 'D', '_', '8')) {
+            channels = 1;
+            break;
+        }
+    }
+
+    st->codecpar->codec_type = AVMEDIA_TYPE_AUDIO;
+    st->codecpar->channels = channels;
+    st->codecpar->sample_rate = rate;
+    st->codecpar->codec_id = AV_CODEC_ID_PCM_S16LE;
+    st->codecpar->block_align = 2 * channels;
+
+    return 0;
+}
+
+AVInputFormat ff_nsp_demuxer = {
+    .name           = "nsp",
+    .long_name      = NULL_IF_CONFIG_SMALL("Computerized Speech Lab NSP"),
+    .read_probe     = nsp_probe,
+    .read_header    = nsp_read_header,
+    .read_packet    = ff_pcm_read_packet,
+    .read_seek      = ff_pcm_read_seek,
+    .extensions     = "nsp",
+    .flags          = AVFMT_GENERIC_INDEX,
+};